#define _GNU_SOURCE 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <fitsio.h>
#include "SpiceUsr.h"
#include "SpiceDLA.h"
#include "SpiceDSK.h"
#include "pl02.h"

#define  STRLEN 100
#define  BCVLEN 5       //max number of FOV bound vectors
#define  ROOM 10  //add point

int main(int argc, char *argv[]) {
  
  SpiceDouble plnorm[3];
  SpiceInt    plate_id;
  SpiceInt    n_vertices, n_plates;
  SpiceInt    handle;
  SpiceDLADescr dladsc;
  SpiceBoolean *found; //視線上にモデルがあったらture
  

  ///Open DSK file
  dasopr_c ( argv[1], &handle );
  //serch the kernel in the DSK file.
  //If not find DSK file, found is 0.
  dlabfs_c ( handle, &dladsc, &found );
  if ( !found  ) {
    /*
    We arrive here only if the kernel
    contains no segments.  This is
    unexpected, but we're prepared for it.
    */
    setmsg_c ( "No segments found in DSK file #.");
    errch_c  ( "#",  argv[1]                         );
    sigerr_c ( "SPICE(NODATA)"                   );
    }
  
  //dskのポリゴン数，頂点数を調べる
  dskz02_c (handle, &dladsc, &n_vertices, &n_plates);
  
  plate_id = 1; //ポリゴン番号は1から数える
  while (plate_id <= n_plates) {
    //plate_id番目のポリゴンの法線を求める関数
    dskn02_c ( handle, &dladsc, plate_id, plnorm );
    printf("%d\t%f\t%f\t%f\n",plate_id, plnorm[0], plnorm[1], plnorm[2]);
    
    plate_id++;
  }
}

