#!/usr/bin/perl

# extract_focal.pl
#  -- Tool for preparing a directory of images for bundler by computing 
#     focal lengths from Exif tags
# Copyright 2005-2009 Noah Snavely

$BIN_PATH = `dirname $0`;

chomp($BIN_PATH);

$OUT_DIR = "./prepare";

`mkdir $OUT_DIR`;
`rm -f $OUT_DIR/list.txt`;

`rm -f $OUT_DIR/list.gpu.txt`;

print "$#ARGV\n";
$IMAGE_LIST = "";
if ($#ARGV > -1) {
    $IMAGE_LIST = $ARGV[0];
}

$IMAGE_DIR = ".";
if ($#ARGV > 0) {
    $IMAGE_DIR = $ARGV[1];
}

printf("Image list is %s\n", $IMAGE_LIST);

if ($IMAGE_LIST eq "") {
    @images = split(/\n/, `ls -1 $IMAGE_DIR | egrep "\.jpg|\.JPG"`);
} else {
    if ($IMAGE_DIR eq ".") {
        @images = split(/\n/, `awk '{print \$0}' $IMAGE_LIST`);
    } else {
        @images = split(/\n/, `awk '{print "$IMAGE_DIR/" \$0}' $IMAGE_LIST`);
    }
}

$num_output_images = 0;
foreach $img (@images) {

    # Convert to bmp and pgm
    $basename = `echo $img | sed 's/.[jJ][pP][gG]//'`;
    chomp($basename);
    $line = sprintf("%s.jpg 0 10054.931080003", $basename);
    
    `echo $line >> $OUT_DIR/list.txt`;
#	$line = `echo $line | sed 's/\.\//'`;
    $line = sprintf("%s.jpg", $basename);
    `echo $line | sed 's:\./::g'  >> $OUT_DIR/list.gpu.txt`;
    
    $num_output_images++;
}

printf("[Found %d good images]\n", $num_output_images);
